#include <FastLED.h> // FASTLED library

#define NUM_LEDS   342 // Number of LEDs in your pattern
#define LED_PIN  3 // LED Data pin 
int dataIn[7] {0,0,0,0,0,200,0}; //array to store all the informations coming from the BT. 255,selection,slider 1,2,3,4, palette
int in_byte = 0;
int array_index = 0;
bool gReverseDirection = false;
int cooling = 50; int sparking = 60;// Default variables for FIRE Pattern
int delaiRainbow ;
int divRainbow; 
int hue; // Hue Varibale
int vide = 0;
int extrainbow;
int endwall = 162; // the number of the last LED of the WALL pattern


uint8_t   noiseData[NUM_LEDS]; // Variables for NOISE Pattern
uint16_t  timeVal     = 0;
int       scaleVal    = 3;

unsigned long currentTime=0; // Variables for the delay
unsigned long previousTime=0;

CRGBPalette16 Palette(PartyColors_p); // Default Palette
CRGB leds[NUM_LEDS];


int hexa[144] = {     // These numbers are the numbers of each LEDs shaping the 2 Hexagones in my project
  41,42,43,44,45,46,47,48,49,50,51,52,
  77,78,79,80,81,82,83,84,85,86,87,88,
  95,96,97,98,99,100,101,102,103,104,105,106,
  107,108,109,110,111,112,113,114,115,116,117,118,
  125,126,127,128,129,130,131,132,133,134,135,136,
  143,144,145,146,147,148,149,150,151,152,153,154,
  240,241,242,243,244,245,246,247,248,249,250,251,
  258,259,260,261,262,263,264,265,266,267,268,269,
  276,277,278,279,280,281,282,283,284,285,286,287,
  294,295,296,297,298,299,300,301,302,303,304,305,
  312,313,314,315,316,317,318,319,320,321,322,323,
  330,331,332,333,334,335,336,337,338,339,340,341
  };



void setup() {
  
  FastLED.addLeds<WS2812B, LED_PIN, GRB>(leds, NUM_LEDS);
  Serial1.begin(9600); // If you run the code on Arduino Every you need to initialize the Serial1. Erase if running on Classic Nano
  Serial.begin(9600);
  FastLED.clear(true); // Turn OFF all the LEDs
  
  delay(1000); //pause
  
  for (int i=0; i <200; i++) {
  fill_solid(leds, NUM_LEDS, CHSV(20,255,i));  FastLED.show(); // INTRO Sequence. If you want to change the intro color : 20 is orange
} 
  }

void loop () {

 //////////////////////     Connection BT   ////////////////////////

if (Serial1.available() >0) {  //recieve byte from phone
  in_byte = Serial1.read(); //store in byte into a variable
  if (in_byte == (255)) { // if the variable is 255 set the array inxed to 0. this will make sure that every number goes into the correct index
    array_index = 0;}
  
  dataIn[array_index] = in_byte;  //store number into array
  array_index = array_index +1;}

switch(dataIn[1]){ //Pattern Selection

case 0:  menu(); vide = 0;break;
case 1:  fixe(); vide = 0;break;
case 2:  fire();vide = 0; break;
case 3:  rainbow();vide = 0; break;
case 4:  beats();vide = 0;break;
case 5:  dots();vide = 0;break; 
case 6:  hexagones();break;
case 7:  hexagoneplus();vide = 0;break ;
case 8 : split();vide = 0;break; 
case 9 : noise();vide = 0;break;
//case 10: vide = 0;break;
case 11: off();vide = 0;break; 

}
 

FastLED.setBrightness(dataIn[5]); //Set the brightness according to slider4 value
FastLED.show(); //Show ;-)

}

//////////////////////    OUVERTURE   ////////////////////////     
void menu() {
  fill_solid(leds, NUM_LEDS, CHSV(20,255,255)); // Before a pattern is chosen
 
  }


//////////////////////    SOLID   ////////////////////////     
void fixe() {
  
 fill_solid(leds, NUM_LEDS, CHSV(dataIn[2],dataIn[3],dataIn[5]));
}

//////////////////////    FIRE   ////////////////////////   

  void fire()
{

 cooling = dataIn[2];
sparking = dataIn[3];

// Array of temperature readings at each simulation cell
  static uint8_t heat[NUM_LEDS];

  // Step 1.  Cool down every cell a little
    for( int i = 0; i < NUM_LEDS; i++) {
      heat[i] = qsub8( heat[i],  random8(0, ((cooling * 10) / NUM_LEDS) + 2));
    }
  
    // Step 2.  Heat from each cell drifts 'up' and diffuses a little
    for( int k= NUM_LEDS - 1; k >= 2; k--) {
      heat[k] = (heat[k - 1] + heat[k - 2] + heat[k - 2] ) / 3;
    }
    
    // Step 3.  Randomly ignite new 'sparks' of heat near the bottom
    if( random8() < sparking ) {
      int y = random8(7);
      heat[y] = qadd8( heat[y], random8(160,255) );
    }

    // Step 4.  Map from heat cells to LED colors
    for( int j = 0; j < NUM_LEDS; j++) {
      CRGB color = HeatColor( heat[j]);
      int pixelnumber;
      if( gReverseDirection ) {
        pixelnumber = (NUM_LEDS-1) - j;
      } else {
        pixelnumber = j;
      }
      leds[pixelnumber] = color;
    }
}

//////////////////////    RAINBOW   ////////////////////////  

void rainbow() {

  delaiRainbow = map (dataIn[3], 0, 254, 350, 0);
  extrainbow = map ( dataIn[3], 0, 254, 1, 10);
  currentTime=millis();
  
  if((currentTime-previousTime)> delaiRainbow){
    previousTime=currentTime;hue++;  }
  
  switch(dataIn[6]){

case 1: fill_rainbow( leds, NUM_LEDS, hue, dataIn[2] );  break;

case 2: for (int i = 0; i < NUM_LEDS; i++) 
      {leds[i] = CHSV((dataIn[2]-(i/extrainbow)), 255, dataIn[5]);}  break;
}   
}

//////////////////////   BEATS  ////////////////////////  
void beats() {
  
  uint8_t BeatsPerMinute = dataIn[3];
  
  switch(dataIn[6]){

case 1:  Palette = PartyColors_p; break;
case 2:  Palette = HeatColors_p; break;
case 3:  Palette = OceanColors_p; break;

}

  uint8_t beat = beatsin8( BeatsPerMinute, 64, 255);
  
  for( int i = 0; i < NUM_LEDS; i++)   
  {  leds[i] = ColorFromPalette(Palette, hue + (i * 2), beat - hue + (i * dataIn[2]));  }
  
 currentTime=millis();
  if((currentTime-previousTime)> 10){
    previousTime=currentTime;hue++;  }
}

//////////////////////   DOTS  ////////////////////////  
void dots(){

  
   fadeToBlackBy( leds, NUM_LEDS, dataIn[3]);
  int pos = random16(NUM_LEDS);
  int pos1 = random16(NUM_LEDS);
  int pos2 = random16(NUM_LEDS);
  leds[pos] += CHSV( (dataIn[2]-30),255, 255);
  leds[pos1] += CHSV( dataIn[2], 255, 255);
  leds[pos2] += CHSV( (dataIn[2]+30),255,255);
   }



//////////////////////   OFF //////////////////////// 
void off() {
  
  FastLED.clear(true); } // Clear all LEDs


//////////////////////   HEXA  //////////////////////// 
void hexagones() {
  
  if ( vide == 0){
  fill_solid(leds, NUM_LEDS, CHSV(0,0,0)); vide++;}
 
  delaiRainbow = map (dataIn[3], 0, 254, 350, 0);
 
  currentTime=millis();
  if((currentTime-previousTime)> delaiRainbow){
    previousTime=currentTime;hue++; }
 
 switch(dataIn[6]){

  case 1:  for (int i=0; i<144; i++){   
    leds[hexa[i]]= CHSV( dataIn[2], dataIn[3], dataIn[5]); }; break;

  case 2:  for (int i=0; i<144; i++){   
    leds[hexa[i]]= CHSV( hue, (map (dataIn[2], 0, 254, 130, 255)), dataIn[5]); }; break;

} 
}

//////////////////////   HEXA PLUS //////////////////////// 
void hexagoneplus() {
  
    fill_solid(leds, NUM_LEDS, CHSV(dataIn[2],255,dataIn[5])); // Background color
    for (int i=0; i<144; i++){leds[hexa[i]]= CHSV( dataIn[3], 255, dataIn[5]); }; //Hexagon color
    
    if( random8() < dataIn[4]) { // FLASHES
            leds[ random16(NUM_LEDS) ] += CRGB::White;
            leds[ random16(NUM_LEDS) ] += CRGB::Black;;
    }

}

//////////////////////  SPLIT //////////////////////// 

void split() {
  
  delaiRainbow = map (dataIn[4], 0, 254, 350, 0);
 
 currentTime=millis();
  if((currentTime-previousTime)> delaiRainbow){
    previousTime=currentTime;hue++; }
 
 
 switch(dataIn[6]){
 
  case 1: for (int i = 0; i < endwall; i++) {
          leds[i]= CHSV( dataIn[2], 255, dataIn[5]);}
  
          for (int j = (endwall +1); j <NUM_LEDS;j++){
          leds[j]= CHSV( dataIn[3], 255, dataIn[5]);}  break; 

  case 2: for (int i = 0; i < endwall; i++) {
          leds[i]= CHSV( (dataIn[2]+hue), 255, dataIn[5]);}
  
          for (int j = (endwall +1); j <NUM_LEDS ; j++){
          leds[j]= CHSV( (dataIn[3]+hue+126), 255, dataIn[5]);}  break; }
 
 }

//////////////////////  NOISE  //////////////////////// 

void noise()
{ 
    scaleVal = map(dataIn[2], 0,254,0,50);
    switch(dataIn[6]){

case 1:  Palette = CloudColors_p; break;
case 2:  Palette = LavaColors_p; break;
case 3:  Palette = PartyColors_p; break;}
  
 timeVal = (millis() / (map(dataIn[3],0,254,150,2)));

  memset(noiseData, 0, NUM_LEDS);
  fill_raw_noise8(noiseData, 255, 1, 0, scaleVal, timeVal);
  
  for (int i = 0; i < NUM_LEDS; i++) {
      leds[i] = ColorFromPalette(Palette, noiseData[i], noiseData[NUM_LEDS - i - 1]);
  }  


}


 
